/*
	ACPROTECT SCANNER
	status: working ok (up to date)
*/

#include "packers.h"
#include "win.h"



/*
	ScanAcpr() scans the files in the root directory
	looking for Acprotect-generated rubbish.
*/

void ScanAcpr()
{
	SetStatus("scanning... (ACProtect)");



	// ROOT DIR SCAN (works ok)

	char* buf  = new char[BUFSIZE];
	char* buf2 = new char[BUFSIZE];
	char* buf3 = new char[BUFSIZE];

	GetSystemDirectory(buf3,256);
	buf3[3]='*';
	buf3[4]='.';
	buf3[5]='*';
	buf3[6]=0;
	WIN32_FIND_DATA fdata;
	HANDLE sh = FindFirstFile(buf3,&fdata);
	HANDLE hf;
	int fs;

	if (sh!=INVALID_HANDLE_VALUE)
	{
		buf3[3]=0;
		wsprintf(buf,"%s%s",buf3,fdata.cFileName);
		if (
			(strlen(fdata.cFileName)==10) && (GetFileAttributes(buf)&FILE_ATTRIBUTE_HIDDEN)
			)
		{
			hf = CreateFile(
				buf,
				GENERIC_READ,
				FILE_SHARE_READ|FILE_SHARE_WRITE,
				NULL,
				OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL,
				NULL
				);
			fs = GetFileSize(hf,NULL);
			CloseHandle(hf);
			if (fs == 10)
			{
				wsprintf(buf2,"file::%s",buf);
				AddVal(ACPR,buf2);
			}
		}
		while (FindNextFile(sh,&fdata))
		{
			wsprintf(buf,"%s%s",buf3,fdata.cFileName);
			if (
				(strlen(fdata.cFileName)==10) && 
				(GetFileAttributes(buf)&FILE_ATTRIBUTE_HIDDEN)
				)
			{
				hf = CreateFile(
					buf,
					GENERIC_READ,
					FILE_SHARE_READ|FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,
					NULL
					);
				fs = GetFileSize(hf,NULL);
				CloseHandle(hf);
				if (fs == 10)
				{
					wsprintf(buf2,"file::%s",buf);
					AddVal(ACPR,buf2);
				}
			}
		}
		FindClose(sh);
	}



	// SCAN FINISHED

	delete[] buf;
	delete[] buf2;
	delete[] buf3;

	SetStatusReady();
}